'
' -----------------------------------------------------------------------------
' PATCH RAPIDQ32.DLL CLS to Call 'Init Console'       April 30th, 2007  Jacques
' Solves RQPC issue with some console Keywords (Inkey$, Locate, ... )
' -----------------------------------------------------------------------------
'
''pre cmd tiny run enc opt exe con kill nobk

$ESCAPECHARS ON
$TYPECHECK ON
$INCLUDE "RAPIDQ.INC"
'
cls    ' Initialise console with April 30th, 2007 patched Dll
'
SetConsoleTitle "Patch RapidQ32.Dll Cls Code"
'
' Original Code in  RapidQ32.Dll  to be Replaced 
' ----------------------------------------------
' 00486A7C  83 C4 F8                                 add esp,FFFFFFF8h
' 00486A7F  66 C7 04 24 00 00                        mov word ptr [esp],0000h
' 00486A85  66 C7 44 24 02 00 00                     mov word ptr [esp+02h],0000h
'
DefStr sOrgCode = Chr$(&H83) & Chr$(&HC4) & Chr$(&HF8) _
                & Chr$(&H66) & Chr$(&HC7) & Chr$(&H04) & Chr$(&H24) & Chr$(&H00) & Chr$(&H00) _
                & Chr$(&H66) & Chr$(&HC7) & Chr$(&H44) & Chr$(&H24) & Chr$(&H02) & Chr$(&H00) & Chr$(&H00)
                ' (length 16 bytes)
' New Code in to set in RapidQ32.Dll
' ----------------------------------
' 00486A7C     66E8(1B010000               call word 0x011B    ; vers 0x00466B9C = Init console
' 00486A80     83C4F8                      add  esp, byte -8
'              31C0                        xor  eax, eax
'              89442402                    mov  [esp+2], eax
'
DefStr sNewCode = Chr$(&HE8) & Chr$(&H1B) & Chr$(&H01) & Chr$(00) & Chr$(00) _
                & Chr$(&H83) & Chr$(&HC4) & Chr$(&HF8) _
                & Chr$(&H31) & Chr$(&HC0) _
                & Chr$(&H89) & Chr$(&H44) & Chr$(&H24) & Chr$(&H02) _
                & Chr$(&H90) & Chr$(&H90)  ' nop nop    (length 16 bytes)

PATCHFILE:
'
' SELECT DLL FILE TO PATCH
' ------------------------

Dim OpenDialog AS QOpenDialog
DefStr sOldDir, sFileDll
OpenDialog.Filter = "Dll files|*.Dll|All Files|*.*"
OpenDialog.FilterIndex = 1
sOldDir = CurDir$
OpenDialog.InitialDir = "c:\\"
If OpenDialog.Execute Then
    sFileDll = OpenDialog.FileName
Else
    ShowMessage ("You selected No File\n\n I QUIT QUIT.")
    Application.Terminate
End If
ChDir sOldDir
'
' Open RapidQ32*.Dll File to patch
' --------------------------------
Dim fileDll As QFileStream
DefStr sDll
DefInt ptrCode
'
With fileDll
    .Open (sFileDll, fmOpenReadWrite)
        sDll = .ReadBinStr(.Size)
        ptrCode = Instr (sDll, sOrgCode)
        If ptrCode > 0 Then
            Print "Found Code to Replace at file position: &H" & Hex$(ptrCode - 1)
            If Instr (ptrCode + 15, sDll, sOrgCode) <> 0 Then
                ShowMessage ("Code to Replace has been found twice ??\n\nI cant solve that.\n\nI WILL QUIT, NOTHING DONE")
                Application.Terminate
            End If
            ' Copy Patch in Dll
            .Position = ptrCode - 1
            .WriteBinStr (sNewCode, 16)
            Print "\n\nREPLACEMENT  DONE"
        Else
            Print "\n\nCANT FIND CODE TO REPLACE\n\n    FINISHED: NOTHING DONE"    
        End If
    .Close
End With
'
' PATCH ANOTHER DLL OR NOT
If MessageDlg("Do you want to patch another DLL ???", mtConfirmation, mbOK OR mbCancel, 0) = IdCancel Then
    Application.Terminate
End If

Goto PATCHFILE
' -----------------------------------------------------------------------------
'
